﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.OleDb;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Printing_FG
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            c1FlexGrid1.DataSource = GetDataTable("Products");
            c1FlexGrid1.AutoSizeCols();
        }

        private void printPreviewToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //seting the page setting to landscape, to show whole grid width
            c1FlexGrid1.PrintParameters.PrintDocument.DefaultPageSettings.Landscape = true;

            //customize header
            c1FlexGrid1.PrintParameters.HeaderFont = new Font(FontFamily.GenericSansSerif, 14);
            c1FlexGrid1.PrintParameters.Header = "\t" + (c1FlexGrid1.DataSource as DataTable).TableName;
            
            //customize footer
            c1FlexGrid1.PrintParameters.Footer = "This is my custom Footer Text \t\t Page {0} of {1}";

            //show Print Preview Dialog
            c1FlexGrid1.PrintGrid("Sample Grid", C1.Win.C1FlexGrid.PrintGridFlags.ShowPreviewDialog);
        }

        #region sample datasource for the grid
        DataTable GetDataTable(string tableName)
        {
            // set up connection string
            var conn = GetConnectionString();

            // set up SQL statement
            var rs = $"Select * from [{tableName}]";

            // retrieve data into DataSet
            var da = new OleDbDataAdapter(rs, conn);
            var ds = new DataSet();
            da.Fill(ds, $"{tableName}");

            // return data table
            return ds.Tables[0];
        }
        static string GetConnectionString()
        {
            //path of the sample database installed with ComponentOne samples
            var path = Environment.GetFolderPath(Environment.SpecialFolder.Personal) + @"\ComponentOne Samples\Common";
            var conn = @"provider=microsoft.jet.oledb.4.0;data source={0}\c1nwind.mdb;";
            return string.Format(conn, path);
        }

        #endregion
    }
}
